C# Class Revit.SDK.Samples.NewRebar.CS.GeometrySupport

Compute geometry information and store geometry information.
Datei anzeigen Open project: AMEE/revit Class Usage Examples

Protected Properties

Property Type Description
m_drivingLine System.Line
m_drivingVector Autodesk.Revit.DB.XYZ
m_edges List
m_solid Solid
m_transform Transform

Public Methods

Method Description
GeometrySupport ( FamilyInstance element ) : System

constructor

OffsetPoints ( double offset ) : List

Offset the points of the swept profile to make the points inside swept profile

Protected Methods

Method Description
GetDrivingLineLength ( ) : double

Get the length of driving line

GetRelatedVectors ( Autodesk point ) : List

Get two vectors, which indicate some edge direction which contain given point, set the given point as the start point, the other end point of the edge as end

Transform ( Autodesk point ) : Autodesk.Revit.DB.XYZ

Transform the point to new coordinates

Private Methods

Method Description
ChangeEdgeToLine ( EdgeArray edges ) : List

Change the swept profile edges from EdgeArray type to line list

GetSweptProfile ( Solid solid ) : bool

Find the information of the swept profile(face), and store the points and edges of the profile(face)

GetSweptProfileFace ( Solid solid ) : Face

Get the swept profile(face) of the host object(family instance)

Method Details

GeometrySupport() public method

constructor
public GeometrySupport ( FamilyInstance element ) : System
element FamilyInstance The host object, must be family instance
return System

GetDrivingLineLength() protected method

Get the length of driving line
protected GetDrivingLineLength ( ) : double
return double

GetRelatedVectors() protected method

Get two vectors, which indicate some edge direction which contain given point, set the given point as the start point, the other end point of the edge as end
protected GetRelatedVectors ( Autodesk point ) : List
point Autodesk A point of the swept profile
return List

OffsetPoints() public method

Offset the points of the swept profile to make the points inside swept profile
public OffsetPoints ( double offset ) : List
offset double Indicate how long to offset on two directions
return List

Transform() protected method

Transform the point to new coordinates
protected Transform ( Autodesk point ) : Autodesk.Revit.DB.XYZ
point Autodesk The point need to transform
return Autodesk.Revit.DB.XYZ

Property Details

m_drivingLine protected_oe property

the extend or sweep path of the beam or column
protected Line,System m_drivingLine
return System.Line

m_drivingVector protected_oe property

the director vector of beam or column
protected XYZ,Autodesk.Revit.DB m_drivingVector
return Autodesk.Revit.DB.XYZ

m_edges protected_oe property

a list to store the edges
protected List m_edges
return List

m_solid protected_oe property

store the solid of beam or column
protected Solid m_solid
return Solid

m_transform protected_oe property

the transform value of the solid
protected Transform m_transform
return Transform